;
; Startup code for cc65 (Vic20 version)
;

        .export         _exit
        .export         __STARTUP__ : absolute = 1      ; Mark as startup
        .import         initlib, donelib
        .import         zerobss, push0, _getkey
        .import         _main
        .import         RESTOR, BSOUT, CLRCH
        .import         __MAIN_START__, __MAIN_SIZE__   ; Linker generated
        .import         __STACKSIZE__                   ; Linker generated
        .importzp       ST

	.export		_printmsg

        .exportzp	_i, _j, _Itm1, _CRoom, _CurPos, _CurItem, _s, _Vrb, _c
        .exportzp	_CRm, _CurRoomInv, _e, _ItemPtr, _s2

        .import         _printc, _printcr, _prints, _printscr, _printtok, _Message

        .include        "zeropage.inc"
        .include        "vic20.inc"

; ------------------------------------------------------------------------
; Startup code

.segment        "STARTUP"

Start:

; Save the zero-page locations that we need.

;        ldx     #zpspace-1
;L1:     lda     sp,x
;        sta     zpsave,x
;        dex
;        bpl     L1

; Switch to the second charset.

        lda     #14
        jsr     BSOUT

; Clear the BSS data.

        jsr     zerobss


; Save some system stuff; and, set up the stack.

;        tsx
;        stx     spsave          ; Save the system stack ptr

        lda     #<(__MAIN_START__ + __MAIN_SIZE__ + __STACKSIZE__)
        ldx     #>(__MAIN_START__ + __MAIN_SIZE__ + __STACKSIZE__)
        sta     sp
        stx     sp+1            ; Set argument stack ptr

; Call the module constructors.

        ;jsr     initlib

; Push the command-line arguments; and, call main().

        ;jsr     callmain
	jsr	_main

; Back from main() [this is also the exit() entry]. Run the module destructors.

_exit:  ;pha                     ; Save the return code on stack
        ;jsr     donelib

; Copy back the zero-page stuff.

;        ldx     #zpspace-1
;L2:     lda     zpsave,x
;        sta     sp,x
;        dex
;        bpl     L2

; Place the program return code into BASIC's status variable.

;        pla
;        sta     ST

; Restore the stack pointer.

;        ldx     spsave
;        txs

; Back to BASIC.

;        rts
	jmp	($FFFC)

; ------------------------------------------------------------------------

.zeropage
_i:		.res	1
_j:		.res	1
_Itm1:		.res	1
_CRoom:		.res	1
_CurPos:	.res	1
_CurItem:	.res	1
_s:		.res	2
_Vrb:		.res	1
_c:		.res	1
_CRm:		.res	2
_CurRoomInv:	.res	2
_e:		.res	1
_ItemPtr:	.res	2
_s2:		.res	2

.code

_printmsg:
	asl
	tay
	lda	_Message+1,y
	tax
	lda	_Message,y
	;jsr	_printtok
	jmp	_printscr
