;
; Ullrich von Bassewitz, 2003-08-20
; Performance increase (about 20%) by
; Christian Krueger, 2009-09-13
;
; void* __fastcall__ memcpy (void* dest, const void* src, size_t n);
;
; NOTE: This function contains entry points for memmove, which will ressort
; to memcpy for an upwards copy. Don't change this module without looking
; at memmove!
;

        .export         _memcpy2
        .import         popax, popptr1, _DefRoomItems
        .importzp       sp, ptr1, ptr2, ptr3

_NumRooms=1;

; ----------------------------------------------------------------------
_memcpy2:
	sta	ptr2
	stx	ptr2+1
	lda	#<_DefRoomItems
	sta	ptr1
	lda	#<_DefRoomItems
	sta	ptr1
	lda	#<(_NumRooms<<3)
	sta	ptr3
	lda	#>(_NumRooms<<3)
	sta	ptr3+1
        ldx     ptr3+1          ; Get high byte of n
        beq     L2              ; Jump if zero
	ldy	#0

L1:     .repeat 2               ; Unroll this a bit to make it faster...
        lda     (ptr1),Y        ; copy a byte
        sta     (ptr2),Y
        iny
        .endrepeat
        bne     L1
        inc     ptr1+1
        inc     ptr2+1
        dex                     ; Next 256 byte block
        bne     L1              ; Repeat if any

        ; the following section could be 10% faster if we were able to copy
        ; back to front - unfortunately we are forced to copy strict from
        ; low to high since this function is also used for
        ; memmove and blocks could be overlapping!
        ; {
L2:                             ; assert Y = 0
        ldx     ptr3            ; Get the low byte of n
        beq     done            ; something to copy

L3:     lda     (ptr1),Y        ; copy a byte
        sta     (ptr2),Y
        iny
        dex
        bne     L3

        ; }

done:   ;mp     popax           ; Pop ptr and return as result
	rts

