/***********************************************************************
 * 
 * Individual module for the cc65 compiler.
 *
 * The template for this file was created by TempC Module Creator by
 * Joseph Rose.  This template can be used in your programs, provided
 * you mention TempC in your software's documentation.  If this source
 * code is distributed, this copyright must be included in the file.
 *
 ***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <errno.h>
#include <ctype.h>

//Used by printtok() to hold current character in string.
extern unsigned char i;
#pragma zpsym ("i")

//Pointer to current location in the string gto print.
extern char* s;
#pragma zpsym ("s")

//Declarations to two routine from CBMSimpleIO and AtaSimpleIO used
//to print information.
void __fastcall__ printc(char);		//Prints single char.
void __fastcall__ prints (char*);	//Prints whole string,
					//used to print a token's text.

//If using a 32k cartridge, define function to access a byte from the second 16k of a
//cartridge, as the text will be stored there.
#ifdef __DOFE3__
unsigned char __fastcall__ bankgetbyte (void*);
#endif

//Insert your tokens here.
//This holds the first 32 tokens.
//Refer to these tokens  by writing the escape sequence \x80 and
//add the token # to the escape sequence.  If programming
//for gthe Atari 8-bit series, use \xA0 instead.
static char * tokens[]=
{
	// "Mars"
}, 
//More tokens.  Refer to these with a % followed by a lowercase letter.

* tokens2a[]= {
	// "Microsoft",
	// "Harry Potter"
},
//Even more tokens.  Use if needed.  Refer with an uppercase letter.
* tokens2b[]=
{
	// "Illegal function call."
}
;


//RLE for spaces instructions:
//
//If you want to print at least three spaces, you can use
//the escape sequence \x05 followed by a digit 3 less then
//the number of spaces you need.  Maximum is 12 spaces
//at a time.

//This function prints the string given in str to the screen
//with one difference: if a string literal between 0x80 and 0x9F
//is found, it will print the token # that literal-0x80.
//
//BTW, you need to include this prototype in your
//program's modules.

//Code to handle 32k cartridges.
#ifdef __DOFE3__
void __fastcall__ printtok (char* str)
{
	//Get current char until NUL.
	while (i=bankgetbyte(str)) {
		//If a quick-token (i.e. a one-byte token),
		//print the text associated with the token.
		//You have 32 quick tokens.  They range from
		//0xA0 to 0xBF on an Atari8 and 0x80 to 0x9F
		//on CBM computers.  Their definitions are in the
		//tokens array above.
#ifdef __ATARI__
		if (i>=0xA0 && i<0xC0) prints (tokens[i&0x1F]);
#else
		if (i>=0x80 && i<0xA0) prints (tokens[i&0x1F]);
#endif
		//Process extended tokens, two-byte tokens starting with a 
		//'%' followed by an upper-case or lower-case letter.
		//Numbers are planned.
		//
		//Kill this condition if you need no more than 32
		//tokens:
		else if (i=='%') {
			++str; i=bankgetbyte(str);
			//If the second char. is a '%', write a single 
			//'%'.
			if (i=='%') {
				printc ('%');
			}
			//If a lower-case letter, print associated token in
			//the tokens2a array above.
			else if (islower(i)) {
				prints (tokens2a[i-'a']);
			}
			//If an uppercase letter, same but from 
			//the tokens2b array.
			//Kill this condition if you need no
			//more than 58 tokens:
			else if (isupper(i)) {
				prints (tokens2b[i-'A']);
			}
		} else if (i==5) {
			//If the current char. in the output string is
			//a value 5, print 3 more the the following digit
			//number of spaces.
			++str; i=bankgetbyte(str)-'0'+3;
			while (i--) printc (' ');
		} //Otherwise, print char.
		else printc (i);
		//Advance.
		++str;
	}
}
#else
	//Code to handle all other instances.
void __fastcall__ printtok (char* str)
{
	//Cache the string pointer in zp for faster access.
	s=str;
	//Get current char until NUL.
	while (i=*s) {
		//If a quick-token (i.e. a one-byte token),
		//print the text associated with the token.
		//You have 32 quick tokens.  They range from
		//0xA0 to 0xBF on an Atari8 and 0x80 to 0x9F
		//on CBM computers.  Their definitions are in the
		//tokens array above.
#ifdef __ATARI__
		if (i>=0xA0 && i<0xC0) prints (tokens[i&0x1F]);
#else
		if (i>=0x80 && i<0xA0) prints (tokens[i&0x1F]);
#endif
		//Process extended tokens, two-byte tokens starting with a 
		//'%' followed by an upper-case or lower-case letter.
		//Numbers are planned.
		//
		//Kill this condition if you need no more than 32
		//tokens:
		else if (i=='%') {
			//If the second char. is a '%', write a single 
			//'%'.
			++s; i=*s;
			if (i=='%') {
				printc ('%');
			}
			//If a lower-case letter, print associated token in
			//the tokens2a array above.
			else if (islower(i)) {
				prints (tokens2a[i-'a']);
			}
			//If an uppercase letter, same but from 
			//the tokens2b array.
			//Kill this condition if you need no
			//more than 58 tokens:
			else if (isupper(i)) {
				prints (tokens2b[i-'A']);
			}
			//If the current char. in the output string is
			//a value 5, print 3 more the the following digit
			//number of spaces.
		} else if (i==5) {
			++s; i=*s-'0'+3;
			while (i--) printc (' ');
		} //Otherwise, print char.
		else printc (i);
		//Advance.
		++s;
	}
}
#endif
